package com.bergerkiller.bukkit.nolagg;

import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.world.ChunkUnloadEvent;

import com.bergerkiller.bukkit.nolagg.meta.ChunkMetaData;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;
import com.bergerkiller.bukkit.nolagg.monitor.PerformanceMonitor;
import com.bergerkiller.bukkit.nolagg.spawnlimit.SpawnHandler;

public class NLMonitoredListener implements Listener {
		
	@EventHandler(priority = EventPriority.MONITOR)
	public void onChunkUnload(ChunkUnloadEvent event) {
		if (event.isCancelled()) {
			ChunkMetaData.get(event.getChunk()).markNotUnloadable();
		} else {
			WorldMetaData.get(event.getWorld()).removeChunk(event.getChunk().getX(), event.getChunk().getZ());
			NLListener.unloadedChunks++;
			if (NoLagg.useSpawnLimits) {
				if (NoLagg.isMonitorEnabled) {
					PerformanceMonitor.entitySpawnLimit.start();
				}
				//properly despawn entities
				for (org.bukkit.entity.Entity e : event.getChunk().getEntities()) {
					SpawnHandler.handleDespawn(e);
				}
				if (NoLagg.isMonitorEnabled) {
					PerformanceMonitor.entitySpawnLimit.next();
				}
			}
		}
	}
	
}
